% realimentacion de estado del ascensor
clear all;
close all;
clc;
warning off;
% Datos del sistema
Ra=1.96;
La=0.01;
Kt=2.5;
Kw=2.38;    
Ai=10;

J=5.4;
B1=1275;
K=49000;
M=500;
Bm= .000000001;

N2=50;
N1=1;
r=0.3;
Ts=0.002;

% Parametros de simulink
Aest=zeros(2,2);
Best=zeros(2,3);
Hest=zeros(2,2);
Cest=zeros(2,2);
Dest=zeros(2,3);
Xe0=[0,0];
A0=1;
K1=0;
K2=0;
K3=0;
K4=0;
Vr=440;
Td=0.1;

%Matrices del Sistema

A=[-Ra/La -Kw/La 0 0; Kt*N2^2/(N1^2*J) -B1/J  -K*N2*r/(N1*J) 0; 0 r*N1/N2 0 -1; 0 0 K/M 0];
B=[1000; 0; 0; 0];
% Las salidas ubicadas sobre el motor Ia(t) y W(t)
C=[1 0 0 0;0 1 0 0] ;
D=[0; 0];
P1=ss(A,B,C,D);
clc;

% Modelo de Estado

str1=sprintf('\n Modelo de Estado \n');
disp(str1);
P1


%%
% MODELO DE ESTADOS DISCRETO

close all;
P2=c2d(P1,Ts);
clc;
str1=sprintf('\n Modelo de Estado Discreto \n');
disp(str1);
P2
figure(3)
step(P2,20);
grid on;

%%
% Observabilidad del Modelo
close all;
clc;
P3=ss(P2.a,P2.b,[1 0 0 0],[0],Ts);
str1=sprintf('\n Observabilidad del Modelo de Estado Discreto \n');
disp(str1);
V=obsv(P2)
str1=sprintf('\n Rango de la matriz Observabilidad = %d \n', rank(V));
disp(str1);
str1=sprintf('\n Observabilidad del Modelo respecto de Ia \n');
disp(str1);
Vi=obsv(P3)
str1=sprintf('\n Rango de la matriz Observabilidad = %d \n', rank(Vi));
disp(str1);
P3.c=[0 1 0 0];
str1=sprintf('\n Observabilidad del Modelo respecto de W \n');
disp(str1);
Vw=obsv(P3)
str1=sprintf('\n Rango de la matriz Observabilidad = %d \n', rank(Vw));
disp(str1);

%%
% Diseo del Estimador de Orden Reducido
clc;
str1=sprintf('\n Se va a disear el estimador utilizando las dos salidas \n en este caso el estimador elegido es uno de orden reducido.' );
disp(str1);
% Separacin de variables
str1=sprintf('\n Matriz de transformacin para separar las variables \n');
disp(str1);
T=[0 0 1 0; 0 0 0 1; 1 0 0 0; 0 1 0 0]
disp(' ');
str1=sprintf(' Modelo Transformado \n');
disp(str1);
P4=ss2ss(P2,T)

%%
clc;
disp(' ');
disp('Submatrices del modelo');
At11=P4.a(1:2,1:2)
At12=P4.a(1:2,3:4)
At21=P4.a(3:4,1:2)
At22=P4.a(3:4,3:4)
Bt1=P4.b(1:2,1)
Bt2=P4.b(3:4,1)

%%
% Diseo del estimador
clc;
str1=sprintf('\n Matriz del Estimador \n Ae = A11 - H*A21 \n En este caso la matriz H resultar de 2x2 por tal motivo se \n genera una "variable ficticia" para resolver el problema.');
str2=sprintf('%s\n En este caso el papel de la matriz C lo cumple A21 se debe generar \n  un vector fila entonces resulta F=[1 1]  \n',str1);
disp(str2);
F=[1 1]
C1=F*At21
z1=input('Ingrese el autovalor del estimador z1 = ');

z2=input('Ingrese el autovalor del estimador z2 = ');

str1=sprintf('\n Vector del Estimador del Modelo ficticio \n');
disp(str1);
H1=acker(At11',C1',[z1,z2])'
str1=sprintf('\n Matriz H \n');
disp(str1);
H=H1*F


%%
clc
close all
Aest=At11-H*At21
eig(Aest)
Be=Bt1-H*Bt2
He=At12-H*At22+Aest*H
Best=[Be He]
Cest=eye(2)
Dest=[zeros(2,1),H]
Xe0=[1,1]
% 
% Modelo compuesto
At=[P2.a, zeros(4,2);He*P2.c,Aest];
Bt=[P2.b;Be];
Ct=[eye(4),zeros(4,2);zeros(2,4),eye(2)];
Dt=zeros(6,1);
Pt=ss(At,Bt,Ct,Dt,Ts);

%%
clc;
Vr=5;
disp('  autovalores deseados para el sistema');
disp('  sobrepico= 0 Ts[2%] = 2 seg.');
disp(' ');

polos=[-1.5 -1.5 -15 -22.5]
polosd=exp(Ts*polos)
Kt1=acker(P2.a,P2.b,polosd);

disp('   vector de realimentacion')

Kt1

A5=P2.a-P2.b*Kt1;

P5=ss(A5,P2.b,[0 1 0 0],[0],Ts)
Kx=dcgain(P5)

disp(' Vector de Realimentacion Recalculado')

A0=31.4/Kx

Kt2=Kt1/A0

K1=Kt2(1)
K2=Kt2(2)
K3=Kt2(3)
K4=Kt2(4)

%%
% figure(1)
% plot(Vm.time,Vm.data)
% hold on
% plot(Vm.time,Vm.data,'r')
% 
% figure(2)
% plot(x.time,x.data)
% hold on
% plot(x.time,x.data,'r')
